/*
Inbox

Inbox API can be used for low level integration and enables direct communication with you contact base.   In most cases you will use our interaction templates for communication, but our api also allows you to send message directly.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package inboxapi

import (
	"encoding/json"
	"time"
)

// checks if the ConversationMessage type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ConversationMessage{}

// ConversationMessage struct for ConversationMessage
type ConversationMessage struct {
	Id string `json:"id"`
	GatewayId string `json:"gateway_id"`
	ActivityId *string `json:"activity_id,omitempty"`
	ConversationId string `json:"conversation_id"`
	Conversation *Conversation `json:"conversation,omitempty"`
	Author *CommunicationChannel `json:"author,omitempty"`
	Text *string `json:"text,omitempty"`
	Type MessageType `json:"type"`
	Status MessageStatus `json:"status"`
	Direction string `json:"direction"`
	Source string `json:"source"`
	Data *ConversationMessageData `json:"data,omitempty"`
	ReplyTo *ConversationMessage `json:"reply_to,omitempty"`
	Timestamp time.Time `json:"timestamp"`
	UserEditedAt *time.Time `json:"user_edited_at,omitempty"`
	UserDeletedAt *time.Time `json:"user_deleted_at,omitempty"`
	Info *InfoMessageData `json:"info,omitempty"`
	Labels []string `json:"labels,omitempty"`
}

// NewConversationMessage instantiates a new ConversationMessage object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewConversationMessage(id string, gatewayId string, conversationId string, type_ MessageType, status MessageStatus, direction string, source string, timestamp time.Time) *ConversationMessage {
	this := ConversationMessage{}
	this.Id = id
	this.GatewayId = gatewayId
	this.ConversationId = conversationId
	this.Type = type_
	this.Status = status
	this.Direction = direction
	this.Source = source
	this.Timestamp = timestamp
	return &this
}

// NewConversationMessageWithDefaults instantiates a new ConversationMessage object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewConversationMessageWithDefaults() *ConversationMessage {
	this := ConversationMessage{}
	return &this
}

// GetId returns the Id field value
func (o *ConversationMessage) GetId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Id
}

// GetIdOk returns a tuple with the Id field value
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Id, true
}

// SetId sets field value
func (o *ConversationMessage) SetId(v string) {
	o.Id = v
}

// GetGatewayId returns the GatewayId field value
func (o *ConversationMessage) GetGatewayId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.GatewayId
}

// GetGatewayIdOk returns a tuple with the GatewayId field value
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetGatewayIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.GatewayId, true
}

// SetGatewayId sets field value
func (o *ConversationMessage) SetGatewayId(v string) {
	o.GatewayId = v
}

// GetActivityId returns the ActivityId field value if set, zero value otherwise.
func (o *ConversationMessage) GetActivityId() string {
	if o == nil || IsNil(o.ActivityId) {
		var ret string
		return ret
	}
	return *o.ActivityId
}

// GetActivityIdOk returns a tuple with the ActivityId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetActivityIdOk() (*string, bool) {
	if o == nil || IsNil(o.ActivityId) {
		return nil, false
	}
	return o.ActivityId, true
}

// HasActivityId returns a boolean if a field has been set.
func (o *ConversationMessage) HasActivityId() bool {
	if o != nil && !IsNil(o.ActivityId) {
		return true
	}

	return false
}

// SetActivityId gets a reference to the given string and assigns it to the ActivityId field.
func (o *ConversationMessage) SetActivityId(v string) {
	o.ActivityId = &v
}

// GetConversationId returns the ConversationId field value
func (o *ConversationMessage) GetConversationId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConversationId
}

// GetConversationIdOk returns a tuple with the ConversationId field value
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetConversationIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConversationId, true
}

// SetConversationId sets field value
func (o *ConversationMessage) SetConversationId(v string) {
	o.ConversationId = v
}

// GetConversation returns the Conversation field value if set, zero value otherwise.
func (o *ConversationMessage) GetConversation() Conversation {
	if o == nil || IsNil(o.Conversation) {
		var ret Conversation
		return ret
	}
	return *o.Conversation
}

// GetConversationOk returns a tuple with the Conversation field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetConversationOk() (*Conversation, bool) {
	if o == nil || IsNil(o.Conversation) {
		return nil, false
	}
	return o.Conversation, true
}

// HasConversation returns a boolean if a field has been set.
func (o *ConversationMessage) HasConversation() bool {
	if o != nil && !IsNil(o.Conversation) {
		return true
	}

	return false
}

// SetConversation gets a reference to the given Conversation and assigns it to the Conversation field.
func (o *ConversationMessage) SetConversation(v Conversation) {
	o.Conversation = &v
}

// GetAuthor returns the Author field value if set, zero value otherwise.
func (o *ConversationMessage) GetAuthor() CommunicationChannel {
	if o == nil || IsNil(o.Author) {
		var ret CommunicationChannel
		return ret
	}
	return *o.Author
}

// GetAuthorOk returns a tuple with the Author field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetAuthorOk() (*CommunicationChannel, bool) {
	if o == nil || IsNil(o.Author) {
		return nil, false
	}
	return o.Author, true
}

// HasAuthor returns a boolean if a field has been set.
func (o *ConversationMessage) HasAuthor() bool {
	if o != nil && !IsNil(o.Author) {
		return true
	}

	return false
}

// SetAuthor gets a reference to the given CommunicationChannel and assigns it to the Author field.
func (o *ConversationMessage) SetAuthor(v CommunicationChannel) {
	o.Author = &v
}

// GetText returns the Text field value if set, zero value otherwise.
func (o *ConversationMessage) GetText() string {
	if o == nil || IsNil(o.Text) {
		var ret string
		return ret
	}
	return *o.Text
}

// GetTextOk returns a tuple with the Text field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetTextOk() (*string, bool) {
	if o == nil || IsNil(o.Text) {
		return nil, false
	}
	return o.Text, true
}

// HasText returns a boolean if a field has been set.
func (o *ConversationMessage) HasText() bool {
	if o != nil && !IsNil(o.Text) {
		return true
	}

	return false
}

// SetText gets a reference to the given string and assigns it to the Text field.
func (o *ConversationMessage) SetText(v string) {
	o.Text = &v
}

// GetType returns the Type field value
func (o *ConversationMessage) GetType() MessageType {
	if o == nil {
		var ret MessageType
		return ret
	}

	return o.Type
}

// GetTypeOk returns a tuple with the Type field value
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetTypeOk() (*MessageType, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Type, true
}

// SetType sets field value
func (o *ConversationMessage) SetType(v MessageType) {
	o.Type = v
}

// GetStatus returns the Status field value
func (o *ConversationMessage) GetStatus() MessageStatus {
	if o == nil {
		var ret MessageStatus
		return ret
	}

	return o.Status
}

// GetStatusOk returns a tuple with the Status field value
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetStatusOk() (*MessageStatus, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Status, true
}

// SetStatus sets field value
func (o *ConversationMessage) SetStatus(v MessageStatus) {
	o.Status = v
}

// GetDirection returns the Direction field value
func (o *ConversationMessage) GetDirection() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Direction
}

// GetDirectionOk returns a tuple with the Direction field value
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetDirectionOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Direction, true
}

// SetDirection sets field value
func (o *ConversationMessage) SetDirection(v string) {
	o.Direction = v
}

// GetSource returns the Source field value
func (o *ConversationMessage) GetSource() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Source
}

// GetSourceOk returns a tuple with the Source field value
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetSourceOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Source, true
}

// SetSource sets field value
func (o *ConversationMessage) SetSource(v string) {
	o.Source = v
}

// GetData returns the Data field value if set, zero value otherwise.
func (o *ConversationMessage) GetData() ConversationMessageData {
	if o == nil || IsNil(o.Data) {
		var ret ConversationMessageData
		return ret
	}
	return *o.Data
}

// GetDataOk returns a tuple with the Data field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetDataOk() (*ConversationMessageData, bool) {
	if o == nil || IsNil(o.Data) {
		return nil, false
	}
	return o.Data, true
}

// HasData returns a boolean if a field has been set.
func (o *ConversationMessage) HasData() bool {
	if o != nil && !IsNil(o.Data) {
		return true
	}

	return false
}

// SetData gets a reference to the given ConversationMessageData and assigns it to the Data field.
func (o *ConversationMessage) SetData(v ConversationMessageData) {
	o.Data = &v
}

// GetReplyTo returns the ReplyTo field value if set, zero value otherwise.
func (o *ConversationMessage) GetReplyTo() ConversationMessage {
	if o == nil || IsNil(o.ReplyTo) {
		var ret ConversationMessage
		return ret
	}
	return *o.ReplyTo
}

// GetReplyToOk returns a tuple with the ReplyTo field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetReplyToOk() (*ConversationMessage, bool) {
	if o == nil || IsNil(o.ReplyTo) {
		return nil, false
	}
	return o.ReplyTo, true
}

// HasReplyTo returns a boolean if a field has been set.
func (o *ConversationMessage) HasReplyTo() bool {
	if o != nil && !IsNil(o.ReplyTo) {
		return true
	}

	return false
}

// SetReplyTo gets a reference to the given ConversationMessage and assigns it to the ReplyTo field.
func (o *ConversationMessage) SetReplyTo(v ConversationMessage) {
	o.ReplyTo = &v
}

// GetTimestamp returns the Timestamp field value
func (o *ConversationMessage) GetTimestamp() time.Time {
	if o == nil {
		var ret time.Time
		return ret
	}

	return o.Timestamp
}

// GetTimestampOk returns a tuple with the Timestamp field value
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetTimestampOk() (*time.Time, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Timestamp, true
}

// SetTimestamp sets field value
func (o *ConversationMessage) SetTimestamp(v time.Time) {
	o.Timestamp = v
}

// GetUserEditedAt returns the UserEditedAt field value if set, zero value otherwise.
func (o *ConversationMessage) GetUserEditedAt() time.Time {
	if o == nil || IsNil(o.UserEditedAt) {
		var ret time.Time
		return ret
	}
	return *o.UserEditedAt
}

// GetUserEditedAtOk returns a tuple with the UserEditedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetUserEditedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.UserEditedAt) {
		return nil, false
	}
	return o.UserEditedAt, true
}

// HasUserEditedAt returns a boolean if a field has been set.
func (o *ConversationMessage) HasUserEditedAt() bool {
	if o != nil && !IsNil(o.UserEditedAt) {
		return true
	}

	return false
}

// SetUserEditedAt gets a reference to the given time.Time and assigns it to the UserEditedAt field.
func (o *ConversationMessage) SetUserEditedAt(v time.Time) {
	o.UserEditedAt = &v
}

// GetUserDeletedAt returns the UserDeletedAt field value if set, zero value otherwise.
func (o *ConversationMessage) GetUserDeletedAt() time.Time {
	if o == nil || IsNil(o.UserDeletedAt) {
		var ret time.Time
		return ret
	}
	return *o.UserDeletedAt
}

// GetUserDeletedAtOk returns a tuple with the UserDeletedAt field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetUserDeletedAtOk() (*time.Time, bool) {
	if o == nil || IsNil(o.UserDeletedAt) {
		return nil, false
	}
	return o.UserDeletedAt, true
}

// HasUserDeletedAt returns a boolean if a field has been set.
func (o *ConversationMessage) HasUserDeletedAt() bool {
	if o != nil && !IsNil(o.UserDeletedAt) {
		return true
	}

	return false
}

// SetUserDeletedAt gets a reference to the given time.Time and assigns it to the UserDeletedAt field.
func (o *ConversationMessage) SetUserDeletedAt(v time.Time) {
	o.UserDeletedAt = &v
}

// GetInfo returns the Info field value if set, zero value otherwise.
func (o *ConversationMessage) GetInfo() InfoMessageData {
	if o == nil || IsNil(o.Info) {
		var ret InfoMessageData
		return ret
	}
	return *o.Info
}

// GetInfoOk returns a tuple with the Info field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetInfoOk() (*InfoMessageData, bool) {
	if o == nil || IsNil(o.Info) {
		return nil, false
	}
	return o.Info, true
}

// HasInfo returns a boolean if a field has been set.
func (o *ConversationMessage) HasInfo() bool {
	if o != nil && !IsNil(o.Info) {
		return true
	}

	return false
}

// SetInfo gets a reference to the given InfoMessageData and assigns it to the Info field.
func (o *ConversationMessage) SetInfo(v InfoMessageData) {
	o.Info = &v
}

// GetLabels returns the Labels field value if set, zero value otherwise.
func (o *ConversationMessage) GetLabels() []string {
	if o == nil || IsNil(o.Labels) {
		var ret []string
		return ret
	}
	return o.Labels
}

// GetLabelsOk returns a tuple with the Labels field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ConversationMessage) GetLabelsOk() ([]string, bool) {
	if o == nil || IsNil(o.Labels) {
		return nil, false
	}
	return o.Labels, true
}

// HasLabels returns a boolean if a field has been set.
func (o *ConversationMessage) HasLabels() bool {
	if o != nil && !IsNil(o.Labels) {
		return true
	}

	return false
}

// SetLabels gets a reference to the given []string and assigns it to the Labels field.
func (o *ConversationMessage) SetLabels(v []string) {
	o.Labels = v
}

func (o ConversationMessage) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ConversationMessage) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["id"] = o.Id
	toSerialize["gateway_id"] = o.GatewayId
	if !IsNil(o.ActivityId) {
		toSerialize["activity_id"] = o.ActivityId
	}
	toSerialize["conversation_id"] = o.ConversationId
	if !IsNil(o.Conversation) {
		toSerialize["conversation"] = o.Conversation
	}
	if !IsNil(o.Author) {
		toSerialize["author"] = o.Author
	}
	if !IsNil(o.Text) {
		toSerialize["text"] = o.Text
	}
	toSerialize["type"] = o.Type
	toSerialize["status"] = o.Status
	toSerialize["direction"] = o.Direction
	toSerialize["source"] = o.Source
	if !IsNil(o.Data) {
		toSerialize["data"] = o.Data
	}
	if !IsNil(o.ReplyTo) {
		toSerialize["reply_to"] = o.ReplyTo
	}
	toSerialize["timestamp"] = o.Timestamp
	if !IsNil(o.UserEditedAt) {
		toSerialize["user_edited_at"] = o.UserEditedAt
	}
	if !IsNil(o.UserDeletedAt) {
		toSerialize["user_deleted_at"] = o.UserDeletedAt
	}
	if !IsNil(o.Info) {
		toSerialize["info"] = o.Info
	}
	if !IsNil(o.Labels) {
		toSerialize["labels"] = o.Labels
	}
	return toSerialize, nil
}

type NullableConversationMessage struct {
	value *ConversationMessage
	isSet bool
}

func (v NullableConversationMessage) Get() *ConversationMessage {
	return v.value
}

func (v *NullableConversationMessage) Set(val *ConversationMessage) {
	v.value = val
	v.isSet = true
}

func (v NullableConversationMessage) IsSet() bool {
	return v.isSet
}

func (v *NullableConversationMessage) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableConversationMessage(val *ConversationMessage) *NullableConversationMessage {
	return &NullableConversationMessage{value: val, isSet: true}
}

func (v NullableConversationMessage) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableConversationMessage) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


